const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const onboarding_cases = sequelize.define(
    'onboarding_cases',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      role: {
        type: DataTypes.ENUM,

        values: ['finance_admin', 'provider', 'support'],
      },

      status: {
        type: DataTypes.ENUM,

        values: ['pending', 'active', 'completed'],
      },

      start_date: {
        type: DataTypes.DATE,
      },

      completion_date: {
        type: DataTypes.DATE,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  onboarding_cases.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.onboarding_cases.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.onboarding_cases.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.onboarding_cases.belongsTo(db.users, {
      as: 'assigned_staff',
      foreignKey: {
        name: 'assigned_staffId',
      },
      constraints: false,
    });

    db.onboarding_cases.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.onboarding_cases.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.onboarding_cases.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return onboarding_cases;
};
